{$n+}
{$e+}
unit initvar;

interface

uses crt;

(************************ INITIALIZATION SECTION ***************************)

const
    specsize  =8192;         {spectrum size}
    maxli     =1073741824;      {2^30}
    secsize   =256;
    tcos      =0.707106781;  {cos of 45 degrees}
    tcosq     =0.5;          {cos of 45 degrees squared}
    lwn1      =15798.002;    {largest wavenumber}

type wordrec  = record
               low,high:word;
              end;

     rar      = array[1..specsize] of single;  {array to hold Y data}
     bar      =array[1..secsize] of byte;
     rarptr   =^rar;                           {pointer to rar}


var
  ob,nrod,ns,ks,r,x  :rarptr;  {observed pATR,nrod file,n sample file,k sample
                                file, calculated pATR file, real part for FFT}

  infile,outfile,phys:string;
  rnfile             :string[16]; {nrod file name}

  f1,f2          :file;            {untyped files used for reading head}
  f3             :file of integer; {typed file -> used for reading Y values}
  f4,f5          :text;            {text files}

  Fhead,buf      :bar;  {Fhead stores head, buf stores Y values for writing}
  hdstor         :bar;   {store head of observed pATR in REFLECT}

  f,q,i,b,j      :integer;         {local variables for counting purposes}
  npts,sce       :integer;         {# of points, scaling exponent}
  npts1,nptsf,cycl,one       :integer;
  error1,error2,error3,error4:integer;
  nosc,k                     :integer;
  check1,check2,check3       :integer;
  menuchoice                 :integer;
  imax                       :integer;

  pts,fnu,lnu    :single; { # of points in file, first x value, last x value}
  ym             :single; {maximum Y value}
  delta          :single; {(lnu-fnu)/(npts-1)}
  rmspdf,rmspd,ffp,flp,p,pr,deltaf,wn :single;
  rpow,nrf,fsum,lastw,lastd           :single;
  dmpf                                :real;          (****** dmpf *********)
  scf            :double; {scaling factor}
  sc,w1,w2       :word;   {scaling exponent,(word1,word2-> for reading data}

  rn,wnn         :array[1..40] of single;  {used in interpolation of nrod}

  comp,rep                    :boolean;
  nout,continue,choice,option :char;
  write1,write2,write3,write4,write5 :char;
  finish,cmd,ch               :char;

  nue,s,gam,ninf,ninf2  :real;
  nrod1,nsamp           :real;
  check,xm              :real;



procedure getmemory;
procedure freememory;
procedure initialize;
procedure setcons;
procedure border;
procedure quit;

implementation


procedure getmemory;
begin
  getmem(ob,32768);
  getmem(nrod,32768);
  getmem(ns,32768);
  getmem(ks,32768);
  getmem(r,32768);
  getmem(x,32768);
end;

procedure freememory;
begin
  freemem(ob,32768);
  freemem(nrod,32768);
  freemem(ns,32768);
  freemem(ks,32768);
  freemem(r,32768);
  freemem(x,32768);
end;

procedure initialize;

var
   g:rar;

begin
  for f:=1 to 256 do
   fhead[f]:=0;
  for f:=1 to specsize do
   g[f]:=0.0;
  infile:='';
  outfile:='';
  npts:=0;
  fnu:=0.0;
  lnu:=0.0;
  f:=0;
  b:=0;
end;       {procedure initialize}

procedure setcons;
begin
  comp:=true;  rep:=false;
  continue:='N'; nout:='N';
  ffp:=0.0; flp:=0.0;
  deltaf:=0.0;
  nptsf:=specsize;
  rpow:=1.0;
  dmpf:=1.0;
  choice:='T';
  write1:='N'; write2:='N'; write3:='N'; write4:='N'; write5:='N';
  cycl:=10000;
end;


procedure border;
begin
  clrscr; textmode(co40); textbackground(blue); textcolor(white);
  gotoxy(1,5);writeln('**************************************');
  gotoxy(1,6);writeln('*                                    *');
  gotoxy(1,7);writeln('*                                    *');
  gotoxy(1,8);writeln('*                                    *');
  gotoxy(1,9);writeln('*                                    *');
  gotoxy(1,10);writeln('*                                    *');
  gotoxy(1,11);writeln('*                                    *');
  gotoxy(1,12);writeln('*                                    *');
  gotoxy(1,13);writeln('*                                    *');
  gotoxy(1,14);writeln('*                                    *');
  gotoxy(1,15);writeln('*                                    *');
  gotoxy(1,16);writeln('*                                    *');
  gotoxy(1,17);writeln('*                                    *');
  gotoxy(1,18);writeln('*                                    *');
  gotoxy(1,19);writeln('**************************************');
  gotoxy(6,11);writeln('by J.E. Bertie, H.H. Eysel');
  gotoxy(4,12);writeln('Turbo Pascal Version - R. Manji');
  gotoxy(8,14);writeln('University of Alberta');
  gotoxy(15,16);writeln('July 1990');
end;

procedure quit;
begin
  repeat
    gotoxy(2,24);write('Are you sure you want to quit? (Y or N)  ');
    gotoxy(44,24);clreol;
    readln(finish); finish:=upcase(finish);
  until finish in ['Y','N'];
  if (finish='Y') and (choice='Q') then halt;
end; {procedure quit}

end.  {unit initvar}

(***************************************************************************)


