{$n+}
{$e+}
{$m 35000,0,655360}

program pccirclcal;

uses crt,sio,initvar,printer;

var
   calfile             :string[32];
   number,index,one    :integer;
   rmspdp,nrfp,amount  :single;
   choice,again        :char;
   wn,n1,n2,k2         :array[1..50] of single;
   prn                 :char;


procedure read_calfile;

begin
   gotoxy(1,6);write('Enter name of calfile (.asc extension assumed): ');
   gotoxy(49,6);clreol;
   readln(calfile);
   calfile:=calfile+'.asc';
   {$I-}
   assign(f4,calfile);
   reset(f4);
   {$I+}
   if IOResult <>0 then
   begin
     repeat
       gotoxy(1,7); writeln(#007'File does not exist!  Press <ENTER> to try again. '); readln;
       gotoxy(1,7);clreol; gotoxy(49,6);clreol;
       gotoxy(1,6);write('Enter name of calfile (.asc extension assumed): ');
       readln(calfile);
       calfile:=calfile+'.asc';
       {$I-}
       assign(f4,calfile);
       reset(f4);
       {$I+}
     until IOResult=0;
   end; {if IOResult}
   j:=1;
   writeln('reading in ',calfile,'.... ');
   while not eof(f4) do
   begin
     read(f4,wn[j],n1[j],n2[j],k2[j]);
     inc(j);
   end;
   number:=j-2;
   close(f4);
end;

procedure ATR(var f,l:integer);

var
  i:integer;
  nrs,nss,kss,a1,a2,p,t,aqbq,rs,rp,numerator,denominator :real;

begin
   writeln('calculating pATR....');
   for i:=f to l do
   begin
     nrs:=sqr(nrod^[i]);
     nss:=sqr(ns^[i]);
     kss:=sqr(ks^[i]);
     a1:=nrs*tcosq;
     p:=nss-kss-a1;
     aqbq:=sqrt(p*p+(4*nss*kss));
     a2:=2*nrod^[i]*tcos*sqrt((p+aqbq)/2);
     numerator:=(a1-a2)+aqbq;
     denominator:=a1+a2+aqbq;
     rs:=numerator/denominator;
     t:=exp(nrf*ln(rs));
     p:=t*t;
     r^[i]:=-ln(((p+t)/2))/2.302585093;
   end;  {for i}
end;  {procedure atr}

procedure deviation(var f,l:integer);

var
   i:integer;
   p:real;

begin
   rmspd:=0.0;  p:=0.0;
   for i:=f to l do
   begin
     if r^[i]<>0 then
     begin
       p:=(ob^[i]-r^[i])/ob^[i];
       rmspd:=rmspd+(p*p);
     end;
   end;
   rmspd:=rmspd/l;
   rmspd:=sqrt(rmspd)*100;
end;

procedure results;

begin
  repeat
    writeln('Would you like results to printer? (Y or N) ');
    readln(prn); prn:=upcase(prn);
  until prn in ['Y','N'];
  clrscr;
  if prn='Y' then
    writeln(lst,'Number of reflections is: ',nrf:3:5);
  writeln('Number of reflections is: ',nrf:3:5);
  for j:=1 to number do
  begin
    if prn='Y' then
      writeln(lst,'At: ',wn[j]:5:2,'  observed is: ',ob^[j]:5:5,'   calculated is: ',r^[j]:5:5);
    writeln('At: ',wn[j]:5:2,'  observed is: ',ob^[j]:5:5,'   calculated is: ',r^[j]:5:5);
  end; {for j loop}
  if prn='Y' then
    writeln(lst,'Rmspd is: ',rmspdp:5:5,'% for ',nrf:3:5,' reflections');
  writeln('Rmspd is: ',rmspdp:5:5,'% for ',nrf:3:5,' reflections');
end;

procedure circlcal;
begin
  read_calfile;
  phys:='observed pATR';
  filename(infile);
  readspc(ob^);
  for j:=1 to number do
  begin
    index:=round((wn[j]-fnu)/delta)+1;
    index:=abs(index);
    ob^[j]:=ob^[index];
    nrod^[j]:=n1[j];
    ns^[j]:=n2[j];
    ks^[j]:=k2[j];
  end;
  writeln;
  repeat
    repeat
    {$I-}
      gotoxy(1,11);write('Enter the # of reflections you would like to start with: ');
      gotoxy(58,11);clreol;
      readln(nrf);
    {$I+}
    until IOresult=0;
    repeat
      gotoxy(1,12);write('Would you like to (I)ncrement or (D)ecrement the # of reflections: ');
      gotoxy(68,12);clreol;
      readln(choice);  choice:=upcase(choice);
    until choice in ['I','D'];
    repeat
    {$I-}
      gotoxy(1,13);write('How much would you like to change the # of reflections by: ');
      gotoxy(60,13);clreol;
      readln(amount);
    {$I+}
    until IOresult=0;
    continue:='Y';  rmspdp:=200;  one:=1;
    repeat
       atr(one,number);
       deviation(one,number);
       if rmspdp>rmspd then
       begin
         rmspdp:=rmspd;
         nrfp:=nrf;
         if choice='I' then
           nrf:=nrf+amount
         else
           nrf:=nrf-amount;
       end
       else
       begin
          nrf:=nrfp;
          atr(one,number);
          results;
          continue:='N';
       end;
    until continue='N';
    repeat
      write('Would you like to do another run ? (Y or N) ');
      readln(again);  again:=upcase(again);
    until again in ['Y','N'];
    clrscr;
  until again ='N';
  repeat
     write('Another total run? (Y or N) ');
     readln(finish); finish:=upcase(finish);
  until finish in ['Y','N'];
end;



(******************************* MAIN PROGRAM ******************************)
begin
  getmemory;
  border;
  gotoxy(14,8);writeln('CIRCLCAL');
  gotoxy(13,18);write('Press <ENTER> '); readln;
  textmode(co80); textbackground(blue); textcolor(white);
  finish:='Y';
  repeat
    initialize; setcons;
    clrscr; again:='Y';
    circlcal;
  until finish='N';
  freememory;
  textbackground(black); textcolor(white);
  clrscr;
end.














