C  RsCalc.for used to calculate Rs spectrum from k and n spectra and
C               then,if needed,to calculate pATR spectrum with a given
C               number of reflection.

CC EXAMPLE OF INPUT DATA FILE (RsCalc.ASC)                               
CC     'benzk.SPC' 'benzn.SPC' 'nZnSe.ASC'                  
CC     'RsZnSeBz.spc'                                            

CC EXAMPLE OF INPUT DATA FILE (RsCalc.ASC)                               
CC     'benzk.SPC' 'benzn.SPC' 'nKRS5.ASC'                  
CC     'RsKRS5Bz.spc'

C      Finalized in June, 1992. S.L.Zhang

       CHARACTER*192 COMM
       CHARACTER*12 nfile,kfile,rsfile,nrfile
       REAL NROD(16384),IMAGK(16384),NRF
       DIMENSION REALN(16384),R(16384),P(16384)
       
       WRITE(*,*)' RsCalc      version 06/92'
       OPEN(5,FILE='RsCalc.ASC',STATUS='OLD')
       READ(5,*) kfile,nfile,nrfile
       READ(5,*) rsfile
       CLOSE(5)

       CALL READSC(kfile,imagk,Np,XS,XE,XT,YT,RESO,COMM,IER)
       write(*,2000)kfile,np,xs,xe        
       
       CALL MAKENROD(NRfile,NROD,R,REALN,xs,xe,np)
       
       CALL READSC(nfile,realn,Np,XS,XE,XT,YT,RESO,COMM,IER)
       write(*,2000)nfile,np,xs,xe
       
       CALL REFLCALN(NROD,IMAGK,R,REALN,np)
       CALL WRITESC(rsfile,R,Np,XS,XE,XT,YT,RESO,COMM,IER)
2000   FORMAT(1X,' File ',A12,' contains ',I5,' pts, starting at ',
     + F6.1,', ending at ',F6.1)
       
       WRITE(*,'(A\)')' pATR spectrum needed (y/n) ?  '
       READ(*,'(a)') RSFILE
       IF (RSFILE.EQ.'y'.OR.RSFILE.EQ.'Y') THEN
3000      WRITE(*,'(a\)')' Enter number of reflection (NRF): '
          READ(*,*) NRF
          WRITE(*,'(a\)')' Enter a filename for the calculated pATR: '
          READ(*,'(a)') RSFILE
          DO I=1,NP
          P(I)=R(I)**NRF
          P(I)=-ALOG10(0.5*P(I)*(1.+P(I)))
          END DO
          CALL WRITESC(rsfile,P,Np,XS,XE,XT,YT,RESO,COMM,IER)
          WRITE(*,'(A\)')' Another pATR at different NRF (y/n) ?  '
          READ(*,'(a)') RSFILE
          IF (RSFILE.EQ.'y'.OR.RSFILE.EQ.'Y') GOTO 3000
       ENDIF
       END

       SUBROUTINE REFLCALN(NROD,IMAGK,R,REALN,np)
C      THIS SUBROUTINE CALCULATES REFLECTIVITIES AS A FUNCTION OF
C      WAVENUMBERS. IT NEEDS N,K,N(ROD) SPECTRA.
       
       REAL NROD2,IMAGK2,NROD(*),IMAGK(*),R(*),REALN(*)

c       WRITE(*,*)' REFLCALC BEGINS......'
       DO 20 I=1,NP
       REALN2=REALN(I)*REALN(I)
       IMAGK2=IMAGK(I)*IMAGK(I)
       NROD2 =NROD(I)*NROD(I)
       X=REALN2-IMAGK2-NROD2*0.5
       Y=SQRT(X*X+4.*REALN2*IMAGK2)

       A=SQRT(.5*(X+Y))
       ANR=1.4142136*A*NROD(I)

20     R(I)=(NROD2*0.5-ANR+Y)/(NROD2*0.5+ANR+Y)
c       R(I)=R(I)**REF
c20     R(I)=-ALOG10(0.5*R(I)*(1.+R(I)))
       END

       SUBROUTINE MAKENROD(NAME,NROD,WN,RN,xs,xe,np)
       CHARACTER*12 NAME
       REAL NROD(*),LWN,LNR,WN(*),RN(*)
       
       OPEN(7,FILE=NAME,STATUS='OLD')
       DELTAF=(XE-XS)/(NP-1)
       READ(7,*, END=10) (WN(I),RN(I),I=1,100)
10     CLOSE(7)
       DO 20 I=1,np
       IF(XS.LT.WN(I)) GOTO 20
       FWN=WN(I-1)
       LWN=WN(I)
       FNR=RN(I-1)
       LNR=RN(I)
       IN=I
       GOTO 30
20     CONTINUE
30     H=(FNR-LNR)/(FWN-LWN)
       J=0
       X=XS
40     CONTINUE
       IF(X.LT.LWN) THEN
       IN=IN+1
       FWN=LWN
       LWN=WN(IN)
       FNR=LNR
       LNR=RN(IN)
       H=(FNR-LNR)/(FWN-LWN)
       ELSE
       J=J+1
       NROD(J)=LNR+H*(X-LWN)
       IF(X.LT.XE) GOTO 50
       X=X+DELTAF
       GOTO 40
       ENDIF
       IF(X.GT.XE) GOTO 40
50     CONTINUE
C      WRITE(*,*)' END OF NROD INTERPOLATION'
       END
