$STORAGE:2

	SUBROUTINE READSC(NAME,R,NP,XS,XE,XT,YT,RES,COMM,IER)
C	READSC-
C		THIS ROUTINE READS A SPETRA-CALC(R) (GALACTIC IND.)
C		FILE FORMAT. IT IS A GENERAL PURPOSE ROUTINE SO THAT
C		DATA IN THIS FORM MAY BE ACCESSED AND MANIPULATED
C		WITH FORTRAN.
C	WRITTEN BY	KENNETH W. VAN EVERY
C			HIMONT R&D CENTER
C			800 GREENBANK RD.
C			WILMINGTON, DE 19808
C			(302) 996-5076
C***********************************************************
C	PASSED ARGUMENTS
C
C	NAME	TYPE	USAGE
C	----	----	------------------------------------
C	NAME	CHAR	THE FILENAME TO READ ON DISK
C	R	ARRAY	REAL ARRAY WITH Y DATA
C	NP	INT	NUMBER OF POINTS OF Y DATA
C	XS	REAL	FLOATING POINT VALUE- FIRST X
C	XE	REAL	FLOATING POINT VALUE- LAST X
C	XT	INT*1	X DATA TYPE (SEE SC MANUAL)
C	YT	INT*1	Y DATA TYPE (SEE SC MANUAL)
C	RES	REAL	NOMINAL DATA RESOLUTION
C	COMM	CHAR	ARRAY WITH 192 BYTE COMMENT
C	IER	INT	ERROR CODE  0=NO ERROR
C***********************************************************
C	NOTE BOTH READSC AND WRITESC WHERE CHANGED ON OCT. 25/90 (BY C.D. KEEFE)
C	TO HAVE RES INSTEAD OF RESO PASSED TO AND FROM THE CALLING PROGRAM.
C	ANY ROUTINES CREATED BEFORE THIS DATE BUT RELINKED AFTER MAY NEED
C	TO BE CHANGED BECAUSE OF THIS.
C
C	*** INITIALIZE

	CHARACTER*12	NAME
	CHARACTER*192	COMM
	CHARACTER*8	RESO

	INTEGER*1	I41(4), IMON, IDAY, IHR, IMIN
	INTEGER*1	VER, D4, XT, YT
	INTEGER*2	NP, ISCALE,IYR
	INTEGER*4	RESERVE(8),MAXINT,I4,I

	REAL		R(*), RNP, FACTOR

	EQUIVALENCE  (I4,I41(1))

	MAXINT=#7FFFFFFF
	IER=0

C	*** OPEN THE FILE
	CALL GETCHAN(ICHAN,IER)
C	WRITE(*,'(1X,A12)')NAME(1:12)
	OPEN(UNIT=ICHAN,FILE=NAME,FORM='BINARY',
     &	STATUS='UNKNOWN',ERR=9999)


C	*** READ THE PREAMBLE
	VER=0
	D4=#4D
	READ(ICHAN) VER,D4

C	***
	READ(ICHAN) ISCALE, RNP, XS, XE, XT, YT
	NP=INT(RNP)

C	*** WRITE THE DATE
	READ(ICHAN) IYR,IMON,IDAY,IHR
	READ(ICHAN) IMIN

C	*** RESOLUTION AND RESERVED BYTE, COMMENT
	READ(ICHAN) RESO,RESERVE,COMM
	READ(RESO,'(F4.1,I1)',ERR=8001)RES

C	*** READ THE Y DATA
C	    DESCALE AND STORE THE NUMBERS

8001	FACTOR=((MAXINT/.5)/(2.0**ISCALE))

	DO 20 I=1,NP
	READ(ICHAN) I41(3),I41(4),I41(1),I41(2)

C	 I4= R(I)*FACTOR
	R(I)=REAL(I4)/FACTOR
20	CONTINUE
C	WRITE(*,'(8F9.4)')(R(IK),IK=1,NP)
C	*** FINISH UP AND RETURN NORMAL
	CALL PUTCHAN(ICHAN,IER)
	RETURN
C	ERROR HANDLING AND ABNORMAL RETURNS
C8000	CALL MSG('/RESOLUTION NOT IN FILE/')
C	GOTO 8001
9999	STOP 'ERROR OPENING SPECTRA-CALC FILE IN READSC'
	END


	SUBROUTINE WRITESC(NAME,R,NP,XS,XE,XT,YT,RES,COMM,IER)
C	WRITESC-
C		THIS ROUTINE WRITES A SPETRA-CALC(R) (GALACTIC IND.)
C		FILE FORMAT. IT IS A GENERAL PURPOSE ROUTINE SO THAT
C		DATA OBTAINED FROM ANY SOURCE MAY BE MANIPULATED
C		WITH SC.
C	WRITTEN BY	KENNETH W. VAN EVERY
C			HIMONT R&D CENTER
C			800 GREENBANK RD.
C			WILMINGTON, DE 19808
C			(302) 996-5076
C***********************************************************
C	PASSED ARGUMENTS
C
C	NAME	TYPE	USAGE
C	----	----	------------------------------------
C	NAME	CHAR	THE FILENAME TO WRITE ON DISK
C	R	ARRAY	REAL ARRAY WITH Y DATA
C	NP	INT	NUMBER OF POINTS OF Y DATA
C	XS	REAL	FLOATING POINT VALUE- FIRST X
C	XE	REAL	FLOATING POINT VALUE- LAST X
C	XT	INT*1	X DATA TYPE (SEE SC MANUAL)
C	YT	INT*1	Y DATA TYPE (SEE SC MANUAL)
C	RES	REAL	NOMINAL DATA RESOLUTION
C	COMM	CHAR	ARRAY WITH 192 BYTE COMMENT
C	IER	INT	ERROR CODE  0=NO ERROR
C***********************************************************
C	NOTE BOTH READSC AND WRITESC WHERE CHANGED ON OCT. 25/90 (BY C.D. KEEFE)
C	TO HAVE RES INSTEAD OF RESO PASSED TO AND FROM THE CALLING PROGRAM.
C	ANY ROUTINES CREATED BEFORE THIS DATE BUT RELINKED AFTER MAY NEED
C	TO BE CHANGED BECAUSE OF THIS.
C
C	*** INITIALIZE

	CHARACTER*12	NAME
	CHARACTER*192	COMM
	CHARACTER*8	RESO

	INTEGER*1	I41(4)
	INTEGER*1	VER, D4, XT, YT
	INTEGER*2	NP, ISCALE
	INTEGER*4	RESERVE(8),MAXINT,I4

	REAL		R(*), FACTOR

	EQUIVALENCE  (I4,I41(1))

	MAXINT=#7FFFFFFF
	IER=0

C	*** OPEN THE FILE
C	CALL GETCHAN(ICHAN,IER)
	ICHAN=15
	OPEN(UNIT=ICHAN,FILE=NAME,FORM='BINARY',
     &	STATUS='UNKNOWN',ERR=9999)


C	*** WRITE THE PREAMBLE
	VER=0
	D4=#4D
	WRITE(ICHAN) VER,D4

C	*** DETERMINE SCALING EXPONENT
	CALL AHILO(R,1,NP,RMAX,RMIN)
C	CASE RMAX > .5
	RMAX=ABS(RMAX)
	IF( ABS(RMIN) .GT. RMAX ) RMAX=ABS(RMIN)
C	 WRITE(*,*)RMAX
	IF( RMAX .GE. .5 ) THEN

	   ISCALE=0
1	   IF( RMAX/(2.0**ISCALE) .LT. .5 ) GO TO 50
C	   WRITE(*,*) 'SCALE ',ISCALE
	   ISCALE=ISCALE+1
	   GO TO 1

	ELSEIF( RMAX .GT. 0. )	THEN

	   ISCALE=0
2	   IF( RMAX/(2.0**(ISCALE-1.0)) .GT. 0.5 ) GO TO 50
C	   WRITE(*,*) 'SCALE ',ISCALE
	   ISCALE=ISCALE-1
	   GO TO 2

	ELSE
	STOP 'NO VALUE GT ZERO'
	ENDIF
C50	 WRITE(*,*) ' SCALE FACTOR IS ', ISCALE
50	CONTINUE

C	***
	WRITE(ICHAN) ISCALE, REAL(NP), XS, XE, XT, YT


C	*** WRITE THE DATE
	CALL GETTIM(IHR,IMIN,ISEC,I100TH)
	CALL GETDAT(IYR,IMON,IDAY)
	WRITE(ICHAN) INT2(IYR),INT1(IMON),INT1(IDAY),INT1(IHR)
	WRITE(ICHAN) INT1(IMIN)

C	*** RESOLUTION AND RESERVED BYTE, COMMENT

CC BY SLZ FOR OMITTING COMPILING WARNING MASSEGE
	DO 1111 LZ=1,8
1111	RESERVE(LZ)=0.
CC BY SLZ

	WRITE(RESO,'(F4.1,I1)')RES,0
	WRITE(ICHAN) RESO,RESERVE,COMM

C	*** WRITE THE Y DATA
C	    DESCALE AND STORE THE NUMBERS

	FACTOR=(MAXINT/.5)/(2.0**ISCALE)
	DO 20 I=1,NP
	I4= R(I)*FACTOR
C	 WRITE(*,'(Z)') I4
	WRITE(ICHAN) I41(3),I41(4),I41(1),I41(2)
20	CONTINUE


C	*** FINISH UP AND RETURN NORMAL
	CLOSE(ICHAN)
	RETURN
C	ERROR HANDLING AND ABNORMAL RETURNS
9999	STOP 'ERROR OPENING SPECTRA-CALC FILE IN SCWRITE'
	END


	SUBROUTINE GETNAM(PROMPT,NAME,IFLAG,IER)
	CHARACTER*12   NAME
	CHARACTER*72	PROMPT
C
C	THIS ROUTINE PROMPTS FOR A FILENAME AND CHECKS THAT IT DOES
C	EXIST. I NEED THIS ALL THE TIME.
C
C	THIS ROUTINE IS PART OF THE IMX LIKE SPECTRAL ANALYSIS PACKAGE
C	CONVERTED TO RUN ON XXX/PC COMPATIBLE COMPUTERS. IT IS WRITTEN
C	WITH MICROSOFT FORTRAN 77 VERSION 4.0 AND USES THE MEDIA
C	CYBERNETICS HALO GRAPHICS.
C	WRITTEN AND MODIFIED BY KENNETH W. VAN EVERY
C	UC RIVERSIDE, CA.
C

	LOGICAL FEXIST
	ITR=1
	CALL LENSTR(PROMPT,LEN,IER)
3	WRITE(*,'(2(A)\)') PROMPT(1:LEN),' '
4	READ(*,'(A)',ERR=9001) NAME
C	AVOID ERROR WHEN A BAD NAME IS ENTERED
	INQUIRE(FILE=NAME,EXIST=FEXIST,ERR=9002,IOSTAT=IERR)
 
C	MAKE SURE THE FILE IS THERE.
	IF( IFLAG .EQ. 0 ) RETURN
	INQUIRE(FILE=NAME,EXIST=FEXIST)
	IF( .NOT. FEXIST ) THEN
		IER=0
		WRITE(*,*) ' GETNAME: FILE NOT FOUND - RETYPE.'
		ITR=ITR+1
		IF( ITR .GE.5 ) RETURN
		GO TO 3
	ENDIF
	RETURN
9001	CALL MSG('AN ERROR WAS ENCOUNTERED READING')
	CALL MSG('THAT NAME,  PLEASE RE-ENTER OR')
	CALL MSG('CHOOSE ANOTHER NAME')
	GO TO 3
9002	CALL MSG('SOMETHING IS WRONG WITH THE FILENAME')
	CALL MSG('YOU ENTERED.  PLEASE CHECK FOR ERRORS')
	CALL MSG('OR ILLEGAL CHARACTERS')
	GO TO 3
	END

	SUBROUTINE LENSTR(ASTR,LEN,IER)
	CHARACTER*100 ASTR
C
C	RETURNS THE LENGTH (LEN) OF A STRING ASTR WHICH HAS UNIQUE
C	DELIMITERS AT THE START AND END. DELIMITER MAY BE ANY
C	CHARACTER WHICH DOES NOT OCCUR WITHIN THE VALID SRTING.
C	A \ CHARACTER IS RECOMENDED FOR CONVENTION BUT THE ROUTINE
C	DOES NOT CARE.
C
C	THIS ROUTINE IS PART OF THE IMX LIKE SPECTRAL ANALYSIS PACKAGE
C	CONVERTED TO RUN ON XXX/PC COMPATIBLE COMPUTERS. IT IS WRITTEN
C	WITH MICROSOFT FORTRAN 77 VERSION 4.0 AND USES THE MEDIA
C	CYBERNETICS HALO GRAPHICS.
C	WRITTEN AND MODIFIED BY KENNETH W. VAN EVERY
C	UC RIVERSIDE, CA.
C
C
	IER=1
	DO 1 I=2,100
		IF( ASTR(I:I) .EQ. ASTR(1:1) ) THEN
			LEN=I-1
			RETURN
		ENDIF
1	CONTINUE
	IER=-1
	RETURN
	END

	SUBROUTINE MSG(ASTRING)
C
C	THIS ROUTINE IS PART OF THE IMX LIKE SPECTRAL ANALYSIS PACKAGE
C	CONVERTED TO RUN ON XXX/PC COMPATIBLE COMPUTERS. IT IS WRITTEN
C	WITH MICROSOFT FORTRAN 77 VERSION 4.0 AND USES THE MEDIA
C	CYBERNETICS HALO GRAPHICS.
C	WRITTEN  BY  KENNETH W. VAN EVERY  UC RIVERSIDE, CA.
C
	CHARACTER*50 ASTRING
	CALL LENSTR(ASTRING,J,IER)
2	WRITE(*,'(1X,A)') ASTRING(2:J)
	RETURN
	END


	SUBROUTINE AHILO(ARA,ISP,IEP,RMX,RMN)
C
C	THIS ROUTINE IS PART OF THE IMX LIKE SPECTRAL ANALYSIS PACKAGE
C	CONVERTED TO RUN ON XXX/PC COMPATIBLE COMPUTERS. IT IS WRITTEN
C	WITH MICROSOFT FORTRAN 77 VERSION 4.0 AND USES THE MEDIA
C	CYBERNETICS HALO GRAPHICS.
C	WRITTEN AND MODIFIED BY
C	KENNETH W. VAN EVERY
C	UC RIVERSIDE, CA.
C
C	AHILO
C	FINDS THE REAL MAX (RMX) AND REAL MIN (RMN) VALUES IN THE RANGE
C	BOUNDED BY ISP AND IEP, IN THE REAL ARRAY ARA.
C
	DIMENSION ARA(*)
	INTEGER  ISP,IEP
	RMX=ARA(ISP)
	RMN=ARA(ISP)
C	 WRITE(*,*) 'ISP,IEP',ISP,IEP
	DO 10 I=ISP,IEP
	IF( ARA(I) .GT. RMX ) RMX=ARA(I)
	IF( ARA(I) .LT. RMN ) RMN=ARA(I)
10	CONTINUE
C	 WRITE(*,*) 'RMX,RMN',RMX,RMN
	RETURN
	END

	SUBROUTINE GETCHAN(ICHAN,IER)
C
C	THIS ROUTINE IS PART OF THE IMX LIKE SPECTRAL ANALYSIS PACKAGE
C	CONVERTED TO RUN ON XXX/PC COMPATIBLE COMPUTERS. IT IS WRITTEN
C	WITH MICROSOFT FORTRAN 77 VERSION 4.0 AND USES THE MEDIA
C	CYBERNETICS HALO GRAPHICS.
C	WRITTEN AND MODIFIED BY KENNETH W. VAN EVERY
C	UC RIVERSIDE, CA.
C
C	THIS ROUTINE KEEPS TRACK OF A LIMITED NUMBER OF I/O
C	UNIT NUMBERS. ALTHOUGH NEITHER DOS OR MS-F77 SET THIS LIMIT
C	MOST SYSTEMS RUN WITH FILES=20.
C	THIS FEATURE WAS DESIRABLE FOR COMPATIBILITY WITH DG ROUTINES
C	AND FOR ALLOWING MANY MODULAR SUBPROGRAMS TO BE USED TOGETHER
C	WITHOUT WORRYING ABOUT WHO IS USING WHICH UNIT.
C	THIS ROUTINE IS COMPLEMENTED BY PUTCHAN WHICH IS USED TO
C	CLOSE A CHANNEL AND RETURN IS VALUE TO THE USABLE LIST.
C
C	TO USE THIS ROUTINE, CALL IT BEFORE A CHANNEL MUST
C	BE OPENED. IT RETURNS THE NUMBER OF A CHANNEL THAT
C	IS YET UNCLAIMED. THE CALLING ROUTINE CAN CHECK IER
C	TO MAKE SURE THAT NO ERRORS OCCURED. THIS CHANNEL NUMBER
C	MAY THEN BE OPENED AND USED AS NORMAL. WHEN THE PROGRAM
C	IS DONE WITH THE I/O UNIT IT SHOULD BE CLOSED WITH THE PUTCHAN
C	ROUTINE. THIS CLOSES THE CHANNEL AND RETURNS THE UNIT NUMBER TO
C	THE STACK. THIS ROUTINE WILL NOT RETURN THE NUMBERS OF THE
C	PRECONNECTED I/O CHANNELS (0,5,6). THE I/O UNIT=* IS ALWAYS
C	CONNECTED TO THE SCREEN/KEYBOARD COMBINATION.
C
C	THE SYSTEM BREAKS DOWN OF COURSE IF ROUTINES ARE OPENING
C	CHANNELS NOT TRACKED BY GETCHAN OR NOT RETURNING THE NUMBERS
C	TO PUTCHAN FOR CLOSURE.
C
	COMMON /IOCHAN/ IOCH(20) ,ICHN(20),LEFT
	SAVE
C	 WRITE(*,*) ' GETCHAN '
C	ASSUME NO ERRORS
	IER=1

	IF( LEFT .EQ. 0 ) THEN
		IER=13
		RETURN
		WRITE(*,*) 'GETCHAN: NO MORE I/O UNITS FREE. '
	ENDIF

	ICHAN=0
	DO 10 I=1,20
	IF(ICHN(I) .NE. 1 )THEN
		ICHAN=IOCH(I)
		LEFT=LEFT-1
		ICHN(I)=1
C		 WRITE(*,*) 'LEAVING GETCHAN ' , ICHAN
		RETURN
	ENDIF

10	CONTINUE
	IER =13
	RETURN
	END

	SUBROUTINE PUTCHAN(ICHAN,IER)
C
C	THIS ROUTINE IS PART OF THE IMX LIKE SPECTRAL
C	PACKAGE ADAPTED TO RUN ON I?M COMPATIBLE PCS.
C
C	WRITTEN BY    KENNETH W. VAN EVERY
C		      CHEM. DEPT.
C		      U.C. RIVERSIDE, CA.
C
C	THIS ROUTINE IS THE COUNTERPART OF GETCHAN
C	AND IS USED TO CLOSE A CHANNEL WITH THE
C	UNIT NUMBER PREVIOUSLY OBTAINED FROM GETCHAN.
C	SEE THE COMMENTS IN GETCHAN FOR FURTHER DETAILS.
C
	COMMON /IOCHAN/ IOCH(20) ,ICHN(20) ,LEFT
C
C	THE ARRAY IOCH HAS THE CHANNEL NUMBERS WE ARE KEEPING TRACK OF
C	THE ARRAY ICHN CONTAINS ZEROS OR ONES TO INDICATE WHETHER
C	THE CORRESPONDING CHANNEL IN IOCH IS IN USE.
C	LEFT IS USED TO KEEP TRACK OF THE NUMBER OF CHANNELS
C	IN OUR LIST WHICH ARE STILL AVAILABLE.
C
	SAVE
C	 WRITE(*,*) ' PUTCHAN ', ICHAN
	IER=1
	IF( ICHN(ICHAN) .EQ. 1) THEN
		CLOSE(ICHAN,IOSTAT=IERR)
		ICHN(ICHAN)=0
		IF(LEFT .LT. 20) LEFT=LEFT+1
		IF( IERR .NE. 0) IER=-1
C		WRITE(*,*) 'LEAVING PUTCHAN',IER
		RETURN
	ENDIF

	WRITE(*,*) 'PUTCHAN:  UNIT ', ICHAN , ' WAS NOT OPEN. '
	RETURN
	END

	BLOCK DATA IOC
	COMMON /IOCHAN/ IOCH(20), ICHN(20) ,LEFT
C	THE CHANNELS WE KEEP TRACK OF.
	DATA IOCH/1,2,3,4,7,8,9,10,11,12,13,14,15,16,17,18,19,20,21,22/
	DATA LEFT /20/
	END

	SUBROUTINE GSPCNAM(PROMPT,NAME,IFLAG,IER)
C	THIS ROUTINE IS SAME AS GETNAM EXCEPT ASSUMING SPC AS
C	EXTENSION OF THE FILENAME -- ZHANG, JULY 1990
	CHARACTER*12   NAME
	CHARACTER*72	PROMPT

	LOGICAL FEXIST
	ITR=1
	CALL LENSTR(PROMPT,LEN,IER)
3	WRITE(*,'(2(A)\)') PROMPT(1:LEN),' '
4	READ(*,'(A)',ERR=9001) NAME
	CALL LENSTR1(NAME,LEN,IER)
	LEN1=LEN+1
	LEN4=LEN+4
	NAME(LEN1:LEN4)='.SPC'
C	AVOID ERROR WHEN A BAD NAME IS ENTERED
	INQUIRE(FILE=NAME,EXIST=FEXIST,ERR=9002,IOSTAT=IERR)
 
C	MAKE SURE THE FILE IS THERE.
	IF( IFLAG .EQ. 0 ) RETURN
	INQUIRE(FILE=NAME,EXIST=FEXIST)
	IF( .NOT. FEXIST ) THEN
	   IER=0
	   WRITE(*,*) ' GETNAME: FILE NOT FOUND - RETYPE.'
	   ITR=ITR+1
	   IF( ITR .GE.5 ) RETURN
	   GO TO 3
	ENDIF
	RETURN
9001	CALL MSG('AN ERROR WAS ENCOUNTERED READING')
	CALL MSG('THAT NAME,  PLEASE RE-ENTER OR')
	CALL MSG('CHOOSE ANOTHER NAME')
	GO TO 3
9002	CALL MSG('SOMETHING IS WRONG WITH THE FILENAME')
	CALL MSG('YOU ENTERED.  PLEASE CHECK FOR ERRORS')
	CALL MSG('OR ILLEGAL CHARACTERS')
	GO TO 3
	END

	SUBROUTINE LENSTR1(ASTR,LEN,IER)
	CHARACTER*100 ASTR

	IER=1
	DO 1 I=2,100
	IF( ASTR(I:I) .EQ.' ' ) THEN
	   LEN=I-1
	   RETURN
	   ENDIF
1	CONTINUE
	IER=-1
	RETURN
	END
