C KREF.for(Version 01/1993) for NDP FORTRAN under OS/2 and MS FORTRAN under DOS
CCCCCC PROGRAM KREF -- REFLECT+LZKKT
C      S.L.ZHANG, SEPT.24,1990,
C                 MODIFIED ON OCT.3,1990 ABOUT I/O
C                 LATEST VERSION/JULY,1991:
C                   (MACLAURIN EXPANSION, CORRECTION ON INPUT K,
C                   CRITIC WAVENUMBER AND INTERMEDIATE RESULT
CCCCCCCCCCCCCCC     OUTPUT ON EVERY 5TH CYCLE)
C    OCT 21/1991 -- ASC FILENAME CHANGED FROM kreflect.asc TO kref.asc
C                -- K(I) SET TO ZERO IF Pobs(I) IS LESS THAN 1.6E-5
C                -- VERSION NUMBER "KREF VERSION 10/91" DISPLAYED ON SCREEN
CCCCCCCCCCCCCCC  -- TIMING ADDED TO OUTPUT ASCII FILE
C    July 29,1992, S.L.Zhang, Changes made on
C       adding option of reading missing part of the k spectrum at low cm-1
C       for the K-K transform
C       refinement with a critical cm-1. Full K-K refining will be used after
C       the refining with critical cm-1 is completed.
c
c    January 13,1993, changes made by SLZ
c    (1)Calculations in MAKENROD(n of rod interpolation routine) and REFLCALN 
c       (calculation of pATR from k and n) are in double precision.
c    (2)More information is added to the output file. Now all the parameters 
c       in the input file are output to the output file.
c    (3)File name for the input data now is KREF.asc
c    (4)Version number is changed to Version 01/1993
c    (5)This program is for both MS FORTRAN under DOS and NDP FORTRAN under 
c       OS/2, so the array size is limited to 9336. 
c       There is another version of the program that has array size of 16384 
c       and that can be used in OS/2 only. The program is called KREFb.                 

       LOGICAL OUTC
       INTEGER*1 XT,YT
       INTEGER*2 NFIX,nfix1,ier
       CHARACTER*1 YN
       CHARACTER*3 KRK
       CHARACTER*192 COMM
       CHARACTER*12 NRNAME,ASCNAME,kextra
       CHARACTER*12 PNAME,NNAME,KNAME,KNFINAL,NNFINAL,PNFINAL
       REAL*4  LSUM, LRMS,NINF,NROD,IMAGK
       DIMENSION NROD(9336),IMAGK(9336),P(9336),R(9336)
       dimension x(9336),x2(9336),REALN(9336)
       COMMON/INdat/REF,NP,XS,XE,iread,kextra,RESO,COMM
       COMMON/READ1/REALN
       common/read2/NROD
       common/read3/IMAGK
       common/ntotal/nt

       write(*,*)
       WRITE(*,*)' Welcome to:  KREF (Version 01/1993)'
       write(*,*)

       OPEN(5,FILE='kref.ASC',STATUS='OLD')

       READ(5,*) KRK
       READ(5,*) PNAME,KNAME,NNAME,NRNAME
       READ(5,*) NCB
       READ(5,*) NINF,REF,DAMPF,WNCRITIC,NREST,RLAST
       if (wncritic.le.0) then 
	  wncritic=0.0
	  READ(5,*) LSUM,LRMS
       else
	  read(5,*) lsum,lrms,fsum1
       endif

       READ(5,*) KNFINAL,NNFINAL,PNFINAL

       if (nrest.lt.0) then
	  READ(5,*) ASCNAME,kextra
       else
	  READ(5,*) ASCNAME
	  kextra='NOINPUTK'
       endif

       READ(5,'(A)') YN

       OUTC=.TRUE.
       IF (YN.EQ.'N') OUTC=.FALSE.

       OPEN(6,FILE=ASCNAME,STATUS='UNKNOWN')

       WRITE(6,*)'KREF (Version 01/1993)'
       write(6,*)

       write(6,*) KRK
       write(6,*)
       write(6,*) 'The pATR to be converted is ',PNAME
       write(6,*) 'The initial k spectrum is ',KNAME
       write(6,*) 'The input/calculated n spectrum is ',NNAME
       write(6,*) 'The input n of rod file is ',NRNAME
       write(6,*)
       write(6,'(a,f7.4)')' n(infinity) = ', NINF
       write(6,'(a,f5.2)')' damping factor =',DAMPF
       write(6,'(a,f7.4)')' number of reflection (NRF) = ',REF
       write(6,'(a,f8.2)')' critic cm-1 for the approx. KK =',WNCRITIC
       write(6,'(a,i5,/,a,f7.4)')' # of pts to be added in k spectrum ='
     +         ,NREST,'      with the value at the last point =',RLAST
       write(6,*)
       write(6,'(a,f9.7,a,/,a,f7.5,a)') 
     +  ' Convergence limits are set to ',lsum,
     +  ' for sum squared deviations and ',
     +  '                               ',lrms,
     +  '   for RMS percent deviation'
       write(6,*)

       if (wncritic.gt.0) then 
	  write(6,'(a,/,a,f9.7)')
     +    ' The program will switch to the full KK',
     +    ' when the sum of squared deviation reaches ',fsum1
	  write(6,*)
       endif

       write(6,*)'The final k spectrum is output to ',KNFINAL
       write(6,*)'The final n spectrum is output to ',NNFINAL
       write(6,*)'The calculated pATR spectrum is output to ',PNFINAL
       write(6,*)

       if(nrest.lt.0) then
	  write(6,*)'The extra k spectrum below the low',
     +              ' limit is from ',kextra
	  write(6,*)
       endif

       WRITE(*,*)' READING FILES AND INTERPOLATING N(ROD)......'
       CALL READSC(PNAME,P,NFIX,XS,XE,XT,YT,RESO,COMM,IER)
       WRITE(*,100) PNAME,NFIX,XS,XE
       WRITE(6,100) PNAME,NFIX,XS,XE
       NP=NFIX
       iread=0
       dx=(xs-xe)/float(np-1)
       do i=1,9336
	  xtemp=xs-dx*float(i-1)
	  x(i)=xtemp
	  x2(i)=xtemp*xtemp
       end do

       CALL MAKENROD(NRNAME)
       CALL READSC(KNAME,IMAGK,NFIX,XS,XE,XT,YT,RESO,COMM,IER)
       WRITE(*,100) KNAME,NFIX,XS,XE
       WRITE(6,100) KNAME,NFIX,XS,XE

       IF (KRK.NE.'KRK') THEN
	  CALL READSC(NNAME,REALN,NFIX,XS,XE,XT,YT,RESO,COMM,IER)
	  WRITE(*,100) NNAME,NFIX,XS,XE
	  WRITE(6,100) NNAME,NFIX,XS,XE
       ELSE
	  CALL LZKKTSUB(NINF,WNCRITIC,NREST,RLAST,IMAGK,REALN,x,x2)
	  CALL WRITESC(NNAME,REALN,Nfix,XS,XE,XT,YT,RESO,COMM,IER)
       ENDIF

       DO 101 INCB=1,NCB
       write(*,*)
       WRITE(*,'(2X,A,I4,A,I4)') 'CYCLE: ',INCB,'   OF ',ncb
       WRITE(6,*) ' CYCLE:',INCB

       CALL REFLCALN(R)
       CALL REFINING(NP,DAMPF,P,R,SUMSD,RMSD)

       WRITE(*,200) sumsd,lsum
       WRITE(*,300) rmsd,lrms
       WRITE(6,*)' SUM SQUARED DEVIATION:',SUMSD
       WRITE(6,*)' RMS PERCENT DEVIATION:',RMSD

       IF(SUMSD.LT.LSUM.and.RMSD.LT.LRMS.and.wncritic.eq.0.) GOTO 109
       IF(SUMSD.LT.fsum1) wncritic=0.0

       CALL GETTIM(IH,IM,IS,IS100)
       WRITE(6,923) IH,IM,IS,is100
       CALL LZKKTSUB(NINF,WNCRITIC,NREST,RLAST,IMAGK,REALN,x,x2)
C      WRITE(*,*)' DOING HILBERT TRANSFORM......'
C      CALL SHILBERT(NINF,NP,XS,XE,IMAGK,REALN)
       CALL GETTIM(IH,IM,IS,IS100)
       WRITE(6,924) IH,IM,IS,is100
923    FORMAT('  BEFORE KK, TIME IS ',I2,':',I2.2,':',I2.2,'.',i2.2)
924    FORMAT('  AFTER  KK, TIME IS ',I2,':',I2.2,':',I2.2,'.',i2.2)

       IF(OUTC) THEN
	   READ (5,*,END=99,ERR=99) KNAME,NNAME,PNAME
	   WRITE(*,*)' WRITING 3 FILES......',KNAME,NNAME,PNAME
	   xe1=xs-dx*float(nt-1)
	   nfix1=nt
	   CALL WRITESC(KNAME,IMAGK,Nfix1,XS,XE1,XT,YT,RESO,COMM,IER)
	   CALL WRITESC(PNAME,R    ,Nfix,XS,XE, XT,YT,RESO,COMM,IER)
	   CALL WRITESC(NNAME,REALN,Nfix,XS,XE,XT,YT,RESO,COMM,IER)
       ENDIF

99     IF (INCB/5*5.EQ.INCB) THEN
	 WRITE(*,*)' WRITING 3 FILES...k5thk.spc/n5thk.spc/p5thk.spc'
	 CALL WRITESC('K5THk.spc',IMAGK,Nfix,XS,XE,XT,YT,RESO,COMM,IER)
	 CALL WRITESC('P5THk.spc',R    ,Nfix,XS,XE,XT,YT,RESO,COMM,IER)
	 CALL WRITESC('N5THk.spc',REALN,Nfix,XS,XE,XT,YT,RESO,COMM,IER)
       ENDIF

101    CONTINUE
       WRITE(*,*)' CONVERGENCE LIMIT HAS NOT BEEN REACHED!'
       WRITE(6,*)' CONVERGENCE LIMIT HAS NOT BEEN REACHED!'
       WRITE(*,*)' WRITING THE LAST pATR, n(v) AND k(v) FILES......'
       GOTO 119

109    WRITE(*,*)' ITERATION CONVERGES AT CYCLE:',INCB
       WRITE(6,*)' ITERATION CONVERGES AT CYCLE:',INCB
       WRITE(*,*)' WRITING FITTED RESULTS ......'
       WRITE(6,*)' ITERATION SUCCEEDED!'

119    CONTINUE
       CALL WRITESC(KNFINAL,IMAGK,Nfix,XS,XE,XT,YT,RESO,COMM,IER)
       CALL WRITESC(NNFINAL,REALN,Nfix,XS,XE,XT,YT,RESO,COMM,IER)
       CALL WRITESC(PNFINAL,R    ,Nfix,XS,XE,XT,YT,RESO,COMM,IER)

100    FORMAT(1X,' File ',A12,' contains ',I4,' pts, starting at ',
     + F6.1,', ending at ',F6.1)
200    format(1x,' SUM SQUARED DEVIATION:',6p,F11.1,
     +           'E-6     Limit:',6p,F5.1,'E-6')
300    format(1x,' RMS PERCENT DEVIATION:',3p,F11.1,
     +           'E-3     Limit:',F5.1,'E-3')
       CLOSE(5)
       CLOSE(6)
       END

       SUBROUTINE MAKENROD(NAME)
       INTEGER*1 XT,YT
       INTEGER*2 NFIX,ier
       CHARACTER*12 NAME,kextra
       CHARACTER*192 COMM
       REAL*4 NROD,LWN,LNR,wn(50),rn(50)
       real*8 h,x,deltaf
       COMMON/INdat/REF,NP,XS,XE,iread,kextra,RESO,COMM
       COMMON/READ2/NROD(9336)

       OPEN(7,FILE=NAME,STATUS='OLD')
       DELTAF=(dble(XE)-dble(XS))/dble(NP-1)
       do i=1,50
	  READ(7,*,END=10) WN(I),RN(I)
       end do
10     CLOSE(7)
       DO 20 I=1,9336
	  IF(XS.LT.WN(I)) GOTO 20
	  FWN=WN(I-1)
	  LWN=WN(I)
	  FNR=RN(I-1)
	  LNR=RN(I)
	  IN=I
	  GOTO 30
20     CONTINUE
30     H=(dble(FNR)-dble(LNR))/(dble(FWN)-dble(LWN))
       J=0
       X=dble(XS)
40     CONTINUE
       IF(X.LT.LWN) THEN
	  IN=IN+1
	  FWN=LWN
	  LWN=WN(IN)
	  FNR=LNR
	  LNR=RN(IN)
	  H=(dble(FNR)-dble(LNR))/(dble(FWN)-dble(LWN))
       ELSE
	  J=J+1
	  NROD(J)=LNR+H*(X-dble(LWN))
	  IF(X.LT.XE) GOTO 50
	  X=dble(xs)+DELTAF*dble(J)
	  GOTO 40
       ENDIF
       IF(X.GT.XE) GOTO 40
50     CONTINUE

c      The following is for output n(rod) spc file
       xt=0
       yt=0
       NFIX=NP
       ier=ier
c       CALL WRITESC('nrod.spc',NROD,NFIX,XS,XE,XT,YT,RESO,COMM,IER)
       RETURN
       END

       SUBROUTINE REFLCALN(R)
C      THIS SUBROUTINE CALCULATES REFLECTIVITIES AS A FUNCTION OF
C      WAVENUMBERS. IT NEEDS N,K,N(ROD) SPECTRA.

       INTEGER*2 XX1(110)
       REAL*4 NROD,IMAGK,R(*)
       real*8 nrod2,imagk2,x,y,realn2,a,anr
       COMMON/INdat/REF,NP,XX1
       COMMON/READ1/REALN(9336)
       common/read2/NROD(9336)
       common/read3/IMAGK(9336)

       WRITE(*,*)' REFLCALC BEGINS......'
       DO 20 I=1,NP
       REALN2=dble(REALN(I))**2
       IMAGK2=dble(IMAGK(I))**2
       NROD2 =dble(NROD(I))**2
       X=REALN2-IMAGK2-NROD2*0.5d0
       Y=dSQRT(X*X+4.d0*REALN2*IMAGK2)

       A=dSQRT(.5d0*(X+Y))
       ANR=A*dble(NROD(I))*dsqrt(2.d0)

       R(I)=1.d0-2.d0*ANR/(NROD2*0.5d0+ANR+Y)
       R(I)=R(I)**REF
20     R(I)=-ALOG10(0.5*R(I)*(1.+R(I)))
       RETURN
       END

       SUBROUTINE REFINING(NP,DAMPF,PO,PC,SUMSD1,RMSD1)
       REAL*4 K,PO(*),PC(*)
       real*8 sumsd,rmsd,d,p
       COMMON/READ1/REALN(9336)
       common/read2/RODN(9336)
       common/read3/K(9336)

       WRITE(*,*)' REFINING BEGINS......'
       SUMSD=0.d0
       RMSD=0.d0
       DO 10 I=1,NP
	  IF(PC(I).LE.1.6E-5.OR.PO(I).LE.1.6E-5) goto 10
	  D=dble(PO(I))-dble(PC(I))
	  P=D/dble(PO(I))
	  SUMSD=SUMSD+D*D
	  RMSD=RMSD+P*P
	  ER=PO(I)/PC(I)
	  K(I)=K(I)*(1.+DAMPF*(ER-1.))
10     CONTINUE
       RMSD=dSQRT(RMSD*(1.d4/dble(NP)))
       rmsd1=real(rmsd)
       sumsd1=real(sumsd)
       RETURN
       END


	SUBROUTINE LZKKTSUB(RNINF,XIN,NEXTD,RLAST,RR,RI,x,x2)
	character*12 kextra
	character*192 comm
	DIMENSION RR(*),RI(*),X2(*),XK(9336),x(*)
	COMMON/Indat/REF,NFIX,xs,xe,iread,kextra,reso,comm
	common/ntotal/np

	IF (NFIX.LE.9336) GOTO 5
	STOP ' STOP -- TOO MANY POINTS'

5       H=(Xs-Xe)/(Nfix-1)
C       DEAL WITH THE APPROXIMATION
C       MAKE SURE THAT NL IS AN EVEN NUMBER (PROGRAMMING EASILIER)
	IF (XIN.EQ.0.0) GOTO 8
	NL=abs((XIN-XS)/H)
	NL=NL/2
	NL=NL*2

8       iread=iread+1
	if(iread.ne.1.and.nextd.lt.0) goto 300
	np=nfix
	nmax=abs(xe/h)+1

	if (nextd) 100, 300, 200

c       reading spectrum from disk
100     call appendspc(rr,np,nmax,h)

c       adding a straight line
200     call appendline(nextd,rlast,rr,np,nmax)
	do i=nfix+1,np
	   xk(i)=x(i)*rr(i)
	end do

300     continue
C       CALL WRITESC('kbig.spc',RR,NP2,XS,XE1,XT,YT,RESO,COMM,IER)
C       PAUSE ' PAUSE -- AFTER WRITING THE ENLARGED k SPECTRUM'

20      NPTS=NFIX
	do i=1,nfix
	   xk(i)=x(i)*rr(i)
	end do

	IF (XIN.EQ.0.0.OR.NL.LE.200) THEN
	    CALL KKT(H,NPTS,NP,RI,X2,XK)
	ELSE
	    CALL KKTM(NL,H,NPTS,NP,RI,X2,XK)
	ENDIF

	DO 22 I=1,NFIX
22      RI(I)=RNINF+RI(I)
C       CALL WRITESC(NAME,RI,NFIX,XS,XE,XT,YT,RESO,COMM,IER)
	END

	subroutine appendspc(imagk,nnew,nmax,dx)
	real k1,imagk
	integer*1 xt,yt
	INTEGER*2 n1,ier
	character*12 kextra
	character*192 comm
	dimension k1(4096), imagk(*)
	COMMON/INdat/REF,NFIX,xs,xe,iread,kextra,reso,comm

c       read k spectrum from disk
	call readsc(kextra,k1,n1,xs1,xe1,xt,yt,reso,comm,ier)

	dx1=(xs1-xe1)/float(n1-1)
	ispace=(abs(dx)+0.001)/abs(dx1)
	
c       if no overlap between the original spectrum and the extra k
	if((xe-xs1).gt.(-abs(dx*1.01))) then
		write(*,*)' The extra k spectrum is NOT overlapped',
     +                    ' with the original ! Check and re-run.'
		write(6,*)' The extra k spectrum is NOT overlapped',
     +                    ' with the original ! Check and re-run.'
		close(6)
		stop ' '
c       if the spectrum read from disk has bigger spacing
	elseif(ispace.lt.1) then
		call msg('\  \')
		call msg('\ The extra k spectrum has bigger spacing.\')  
		call msg('\ It needs to be interpolated.\')
		call msg('\ Do interpolation in SpectraCalc and\') 
		call msg('\    re-start the refining !\')
		write(6,*)' The extra k spectrum has a bigger spacing.'
     +                   ,' It needs to be interpolated.'
		write(6,*)' Do interpolation in SpectraCalc and re-',
     +                    'start the refining.'
		close(6)
		stop '  '
c       if the extra k is O.K.
	else
		xstart=xe-dx
		xlimit=dx/100.0
		do i=1,n1
		   xtemp=xs1-dx1*float(i-1)
		   if(abs(xtemp-xstart).lt.xlimit) goto 10
		end do
10              nstart=i

c       if the extra k spectrum is offset from the original spectrum
		if (abs(xtemp-xe1).lt.xlimit) then
			write(*,*)' The extra k is offset in cm-1',
     +                            ' from the original spectrum!'
			write(*,*)' Do interpolation of 2*N and ',
     +                  'truncate odd # of points at the ',
     +                  'high cm-1 side.'
			write(6,*)' The extra k is offset in cm-1',
     +                            ' from the original spectrum!'
			write(6,*)' Do interpolation of 2*N and ',
     +                  'truncate odd # of points at the ',
     +                  'high cm-1 side.'
			close(6)
			stop ' '
		endif
		nadd=(n1-nstart+1)/ispace
		if((nfix+nadd).gt.9336) nadd=9336-nfix
		if (nadd.gt.nmax) nadd=nmax
		do i=1,nadd
		imagk(nfix+i)=k1(nstart+(i-1)*ispace)
		end do
		nnew=nnew+nadd
	endif
	end

	subroutine appendline(nextd,vlast,imagk,nnew,nmax)
	real imagk(*)
	integer*2 xx(110)
	common/indat/ref,nfix,xx
	
	if (nnew.ge.9336) return
	ndd=abs(nextd)
	if (ndd.gt.nmax) ndd=nmax
	ndd=ndd-(nnew-nfix)
	if (ndd.le.0) return
	
	nextdt=nnew+ndd
	if (nextdt.gt.9336) nextdt=9336
	dk=(imagk(nnew)-vlast)/float(nextdt-nnew)

	do i=nnew+1,nextdt
	   imagk(i)=imagk(nnew)-dk*float(i-nnew)
	end do
	nnew=nextdt
	end

      SUBROUTINE KKTM(NL,H,NFIX,N,RN,X2,XK)
C     -- SAME AS KKT EXCEPT USING APPROXIMATIONS
C      REAL*8 HPI,SLOPE,X,X2(9336),XK(9336)
      DIMENSION RN(*),X2(*),XK(*)
C      COMMON/SHAREX2/X2
C      COMMON/SHAREXK/XK

      CALL GETTIM(IH,IM,IS,IS100)
      WRITE(*,923) IH,IM,IS,is100
      HPI=1.2732395447D0*ABS(H)

C     FIRST PART OF THE WHOLE RANGE
      CALL KSUM(2,NL,100,1,N,X2,XK,RN,HPI)

C     SECOND PART OF THE WHOLE RANGE
      N2=NL+200
      CALL KSUM(NL,N2,2,1,N,X2,XK,RN,HPI)
      N1=NL+1
      CALL KSUM(N1,N2,2,2,N,X2,XK,RN,HPI)

C     THIRD PART OF THE WHOLE RANGE
      N1=N2+1
      N2=NFIX
      IF (NFIX.EQ.N) N2=N2-1
      CALL KSUM(N1,N2,2,NL,N,X2,XK,RN,HPI)
      N1=N1+1
      N4=NL-1
      CALL KSUM(N1,N2,2,N4,N,X2,XK,RN,HPI)

C     INTERPOLATING FOR 1ST PART
      NI=(NL-2)/100
      DO 410 I=1,NI
      I2=2+I*100
      I1=I2-100
      SLOPE=RN(I2)-RN(I1)
      I21=I2-1
      I11=I1+1
      DO 410 J=I11,I21
410   RN(J)=RN(I1)+SLOPE*(J-I1)/100.
      I1=2+NI*100
      SLOPE=RN(NL)-RN(I1)
      I21=NL-1
      I11=I1+1
      DO 420 J=I11,I21
420   RN(J)=RN(I1)+SLOPE*(J-I1)/(NL-I1)

      CALL GETTIM(IH,IM,IS,IS100)
      WRITE(*,924) IH,IM,IS,is100
923   FORMAT('  BEFORE KK, TIME IS ',I2,':',I2.2,':',I2.2,'.',i2.2,
     1     /,'  DOING TRANSFORM...KKTM...PLEASE WAIT')
924   FORMAT('  AFTER  KK, TIME IS ',I2,':',I2.2,':',I2.2,'.',i2.2)
      RN(1)=RN(2)
      IF (NFIX.EQ.N) RN(NFIX)=RN(NFIX-1)
      RETURN
      END

      SUBROUTINE KKT(H,NFIX,N,RN,X2,XK)
C      REAL*8 HPI,X,X2(9336),XK(9336)
      DIMENSION RN(*),X2(*),XK(*)
C      COMMON/SHAREX2/X2
C      COMMON/SHAREXK/XK

      CALL GETTIM(IH,IM,IS,IS100)
      WRITE(*,923) IH,IM,IS,is100
      HPI=1.2732395447D0*ABS(H)

      N2=NFIX
      IF (NFIX.EQ.N) N2=N2-1
      CALL KSUM(2,N2,2,1,N,X2,XK,RN,HPI)
      CALL KSUM(3,N2,2,2,N,X2,XK,RN,HPI)

      CALL GETTIM(IH,IM,IS,IS100)
      WRITE(*,924) IH,IM,IS,is100
923   FORMAT('  BEFORE KK, TIME IS ',I2,':',I2.2,':',I2.2,'.',i2.2,
     1     /,'  DOING TRANSFORM...KKT...PLEASE WAIT')
924   FORMAT('  AFTER  KK, TIME IS ',I2,':',I2.2,':',I2.2,'.',i2.2)
      IF (NFIX.EQ.N) RN(NFIX)=RN(NFIX-1)
      RN(1)=RN(2)
      RETURN
      END

      SUBROUTINE KSUM(N1,N2,N3,N4,N5,X2,XK,RN,HPI)
C      REAL  S,HPI,X2(*),XK(*)
      DIMENSION RN(*),X2(*),XK(*)

      DO 130 I=N1,N2,N3
      S=0.0
      DO 125 J=N4,N5,2
125   S=S+XK(J)/(X2(J)-X2(I))
130   RN(I)=HPI*S
      RETURN
      END

	SUBROUTINE LENSTR(ASTR,LEN,IER)
	CHARACTER*100 ASTR
	IER=1
	DO 1 I=2,100
	   IF( ASTR(I:I) .EQ. ASTR(1:1) ) THEN
	       LEN=I-1
	       RETURN
	   ENDIF
1       CONTINUE
	IER=-1
	RETURN
	END

	SUBROUTINE MSG(ASTRING)
	CHARACTER*50 ASTRING
	CALL LENSTR(ASTRING,J,IER)
2       WRITE(*,'(1X,A)') ASTRING(2:J)
	RETURN
	END
