CC     HREF.for (Version 01/1993)
C      Nothing different from MHREF.for except that the program name and
c               data input file name is changed to HREF 
c               and version number is changed to Version 01/1993
c               consistent with KREF - Jan. 1993
CC     PROGRAM MHREF
CCCCCCCC -- REFLECT+HILBERT  CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
CC     S.L.ZHANG, SEPT.24,1990,                                        CC
CC     MODIFIED ON OCT.3,1990 ABOUT I/O                                CC
CC     MODIFIED ON DEC.5,1990 ABOUT SHILBERT  -- SEE THE SUBROUTINE    CC
CC                 APRIL 29,1991, REPLACED SHILBERT WITH NEW HILBERT   CC
CC                                ROUTINE LHLBTSUB                     CC
CCCCCC             JUNE 14, 1991, BUILT IN THE BEST HILBERT ALGORITHM  CC
CCCCCC                                                             CCCCCC
CC EXAMPLE OF INPUT DATA FILE (HREF.ASC)                               CC
CC     'RHR'                                                           CC
CC     'ML10ZP1.SPC' 'M10HKNEW.SPC' 'M10HNNEW.SPC'      'NZNSE.ASC'    CC
CC     6                                                               CC
CC     1.3250   3.30  1.0   1    700  0.0                              CC
CC     0.00005  0.02                                                   CC
CC     'M10HKNEW.SPC' 'M10HNNEW.SPC' 'M10HPNEW.SPC'                    CC
CC     'ML10NEW.ASC'  'kextra.spc'                                     CC
CC     N                                                               CC
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C   OCT 23, 1991 -- # OF POINTS IN THE INPUT pATR SPECTRUM ENLARGED FROM
C                   8192 TO 14000
C                -- VERSION NUMBER CHANGED FROM 06/91 TO 10/91
C   JULY, 1992, BASED ON HREF, MODIFIED TO ALLOW OPTIONS OF ADDING to low
C       cm-1 region a k spectrum given as a disk file in .spc format
C       and calculating the apparent k spectrum, as does CIRCLEP, but
C       using correct number of reflection and n(rod) values.
C       Major changes are in file MHREFZS.for. Linear correction is still
C       valid. Input data filename is changed to MHREF.asc.
C       Version number is changed to Version 07/1992.
C       To finish the refinement, both FSUM and RMSPD limits must be met.
C       For the details of the changes and data input file MHREF.asc, see
C       the program input instructions.   July 29, 1992, S.L.Zhang

       LOGICAL OUTC
       INTEGER*1 XT,YT
       INTEGER*2 NFIX,NN
       CHARACTER*1 YN
       CHARACTER*3 HRH
       CHARACTER*192 COMM
       CHARACTER*12 NRNAME,ASCNAME,kextra
       CHARACTER*12 PNAME,NNAME,KNAME
       CHARACTER*12 KNFINAL,NNFINAL,PNFINAL
       REAL*8 LSUM,LRMS,SUMSD,RMSD
       REAL NINF,NROD(14000),IMAGK(14000)
       DIMENSION REALN(14000),P(14000),R(14000)
       COMMON/IN /REF,NP,XS,XE,XT,YT,RESO,COMM,iread,kextra

       write(*,*)'  Welcome to:  HREF (Version 01/93)'

       OUTC=.TRUE.
       OPEN(5,FILE='href.ASC',STATUS='OLD')
       READ(5,*) HRH

       if(hrh.eq.'HRH'.or.hrh.eq.'RHR'.or.hrh.eq.'CRH') goto 5
       write(*,*)' The mode,',hrh,',is not acceptable'
       stop ' Check the HREF.asc file and re-start'
       
C       READ(5,'(A)') PNAME,KNAME,NNAME,NRNAME,NRNAME1
5      READ(5,*) PNAME,KNAME,NNAME,NRNAME
       READ(5,*) NCB
       READ(5,*) NINF,REF,DAMPF,NZERO,NEXTD,VLAST
       READ(5,*) LSUM,LRMS
C       READ(5,'(3A12)')KNFINAL,NNFINAL,PNFINAL
       READ(5,*) KNFINAL,NNFINAL,PNFINAL
       if (nextd.lt.0) READ(5,*) ASCNAME,kextra
       if (nextd.ge.0) READ(5,*) ASCNAME

       READ(5,'(A)') YN
       IF (YN.EQ.'N') OUTC=.FALSE.

       OPEN(6,FILE=ASCNAME,STATUS='UNKNOWN')

       WRITE(*,*)' READING FILES AND INTERPOLATING N(ROD)......'
       CALL READSC(PNAME,P,NFIX,XS,XE,XT,YT,RESO,COMM,IER)
       SPACE=(XS-XE)/(NFIX-1)
       L1=XS/SPACE+0.5
       L1=L1+1
       NP=NFIX
       iread=0

       WRITE(*,2000) PNAME,NFIX,XS,XE
       WRITE(6, 1500)
       WRITE(6,2000) PNAME,NFIX,XS,XE
       CALL MAKENROD(NRNAME,NROD,IMAGK,REALN)

       if(hrh.eq.'CRH') then
	  Write(*,*)' Calculating k(apparent)...'
	  Write(6,*)' Initial k is calculated from the pATR'
	  do i=1,np
	     imagk(i)=0.576*nrod(i)/ref*sqrt(0.5-(ninf/nrod(i))**2)*p(i)
	     imagk(i)=imagk(i)*(1.0+sqrt(imagk(i)))
	  end do
	  CALL WRITESC(kNAME,imagk,NFIX,XS,XE,XT,YT,RESO,COMM,IER)
       else
	  CALL READSC(KNAME,IMAGK,NFIX,XS,XE,XT,YT,RESO,COMM,IER)
	  WRITE(*,2000) KNAME,NFIX,XS,XE
	  WRITE(6,2000) KNAME,NFIX,XS,XE
       endif

       IF (HRH.ne.'RHR') THEN
C      CALL KKTSUB(NINF,WNCRITIC,NP,XS,XE,IMAGK,REALN)
C         WRITE(*,*)' DOING HILBERT TRANSFORM......'
	  CALL HLBTZSUB(NINF,IMAGK,L1,NEXTD,VLAST,NZERO,REALN)
	  CALL WRITESC(NNAME,REALN,NFIX,XS,XE,XT,YT,RESO,COMM,IER)
       ELSE
	  CALL READSC(NNAME,REALN,NFIX,XS,XE,XT,YT,RESO,COMM,IER)
	  WRITE(*,2000) NNAME,NFIX,XS,XE
	  WRITE(6,2000) NNAME,NFIX,XS,XE
       ENDIF

       DO 99 INCB=1,NCB
       WRITE(*,*)
       WRITE(*,'(2X,A,I4,A,I4)') 'CYCLE: ',INCB,'   OF ',ncb
       WRITE(6,*)
       WRITE(6,*) ' CYCLE:', INCB

       CALL REFLCALN(NROD,IMAGK,R,REALN)
       CALL REFINING(NP,DAMPF,P,R,IMAGK,SUMSD,RMSD)

       WRITE(*,2500) sumsd,lsum
       WRITE(*,3000) rmsd,lrms
       
       WRITE(6,'(A1,A,F12.6)')' ',' SUM SQUARED DEVIATION:',SUMSD
       WRITE(6,'(A1,A,F12.6)')' ',' RMS PERCENT DEVIATION:',RMSD
       
       IF(SUMSD.LT.LSUM.and.RMSD.LT.LRMS) GOTO 109

C      CALL KKTSUB(NINF,WNCRITIC,NP,XS,XE,IMAGK,REALN)
C       WRITE(*,*)' DOING HILBERT TRANSFORM......'
       CALL HLBTZSUB(NINF,IMAGK,L1,NEXTD,VLAST,NZERO,REALN)

       IF(OUTC) THEN
C      diagnostic purpose
	   READ (5,*,END=98,ERR=98) KNAME,NNAME,PNAME
	   WRITE(*,*)' WRITING 3 FILES......',KNAME,NNAME,PNAME
	   xe1=xs-float(L1-1)*space
	   nn=L1
	   CALL WRITESC(KNAME,IMAGK,Nn,  XS,XE1,XT,YT,RESO,COMM,IER)
	   CALL WRITESC(PNAME,R,    nfix,XS,XE, XT,YT,RESO,COMM,IER)
	   CALL WRITESC(NNAME,REALN,Nfix,XS,XE,XT,YT,RESO,COMM,IER)
       ENDIF

98     IF ((INCB/5)*5.EQ.INCB) THEN
	   WRITE(*,*)' WRITING 3 FILES EVERY 5TH CYCLE......',
     +               'k5thh.spc    n5thh.spc    p5thh.spc'
	   CALL WRITESC('k5thh.spc',IMAGK,NFIX,XS,XE,XT,YT,RESO,COMM,IE)
	   CALL WRITESC('n5thh.spc',REALN,NFIX,XS,XE,XT,YT,RESO,COMM,IE)
	   CALL WRITESC('p5thh.spc',R    ,NFIX,XS,XE,XT,YT,RESO,COMM,IE)
       ENDIF

99     CONTINUE
       WRITE(*,*)
       WRITE(*,*)' CONVERGENCE LIMIT HAS NOT BEEN REACHED!'
       WRITE(*,*)' WRITING THE LAST pATR, n(v) AND k(v) FILES......'
       WRITE(6,*)
       WRITE(6,*)' CONVERGENCE LIMIT HAS NOT BEEN REACHED!'
       GOTO 119

109    WRITE(*,*)' ITERATION CONVERGES AT CYCLE:',INCB
       WRITE(*,*)' ITERATION SUCCEEDED!'
       WRITE(*,*)' WRITING FITTED RESULTS ......'
       WRITE(6,*)
       WRITE(6,*)' ITERATION CONVERGES AT CYCLE:',INCB
       WRITE(6,*)' ITERATION SUCCEEDED!'
119    CONTINUE
       CALL WRITESC(KNFINAL,IMAGK,NFIX,XS,XE,XT,YT,RESO,COMM,IER)
       CALL WRITESC(NNFINAL,REALN,NFIX,XS,XE,XT,YT,RESO,COMM,IER)
       CALL WRITESC(PNFINAL,R    ,NFIX,XS,XE,XT,YT,RESO,COMM,IER)
1500   FORMAT(1X,' mHREF Version 07/1992',/)
2000   FORMAT(1X,' File ',A12,' contains ',I4,' pts, starting at ',
     + F6.1,', ending at ',F6.1)
2500   format(1x,' SUM SQUARED DEVIATION:',6p,F11.1,
     +           'E-6     Limit:',6p,F5.1,'E-6')
3000   format(1x,' RMS PERCENT DEVIATION:',3p,F11.1,
     +           'E-3     Limit:',F5.1,'E-3')
       CLOSE(5)
       CLOSE(6)
       END

       SUBROUTINE REFLCALN(NROD,IMAGK,R,REALN)
C      THIS SUBROUTINE CALCULATES REFLECTIVITIES AS A FUNCTION OF
C      WAVENUMBERS. IT NEEDS N,K,N(ROD) SPECTRA.

       INTEGER*2 XX1(111)
       REAL NROD2,IMAGK2,NROD(*),IMAGK(*),R(*),REALN(*)
       COMMON/IN /REF,NP,XX1

       WRITE(*,*)' REFLCALC BEGINS......'
       DO 20 I=1,NP
       REALN2=REALN(I)*REALN(I)
       IMAGK2=IMAGK(I)*IMAGK(I)
       NROD2 =NROD(I)*NROD(I)
       X=REALN2-IMAGK2-NROD2*0.5
       Y=SQRT(X*X+4.*REALN2*IMAGK2)

       A=SQRT(.5*(X+Y))
       ANR=1.4142136*A*NROD(I)

       R(I)=(NROD2*0.5-ANR+Y)/(NROD2*0.5+ANR+Y)
       R(I)=R(I)**REF
20     R(I)=-ALOG10(0.5*R(I)*(1.+R(I)))
       END

       SUBROUTINE REFINING(NP,DAMPF,PO,PC,K,SUMSD,RMSD)
       REAL K(*),PO(*),PC(*)
       REAL*8 SUMSD,RMSD,P,D

       WRITE(*,*)' REFINING BEGINS......'
       SUMSD=0.D0
       RMSD =0.D0
       DO 10 I=1,NP
       IF(PO(I).LE.1.6E-5.or.Pc(I).LE.1.6E-5) GOTO 10
       D=PO(I)-PC(I)
       P=D/PO(I)
       SUMSD=SUMSD+D*D
       RMSD=RMSD+P*P
       ER=PO(I)/PC(I)
       K(I)=K(I)*(1.+DAMPF*(ER-1.))
10     CONTINUE
       RMSD=SQRT(RMSD*(1.D04/NP))
       END

       SUBROUTINE MAKENROD(NAME,NROD,WN,RN)
       INTEGER*1 XT,YT
C       INTEGER*2 NFIX
       CHARACTER*12 NAME
       CHARACTER*192 COMM
       REAL NROD(*),LWN,LNR,WN(*),RN(*)
       COMMON/IN /REF,NP,XS,XE,XT,YT,RESO,COMM,xx(4)

       OPEN(7,FILE=NAME,STATUS='OLD')
       DELTAF=(XE-XS)/(NP-1)
       READ(7,*, END=10) (WN(I),RN(I),I=1,100)
10     CLOSE(7)
       DO 20 I=1,14000
       IF(XS.LT.WN(I)) GOTO 20
       FWN=WN(I-1)
       LWN=WN(I)
       FNR=RN(I-1)
       LNR=RN(I)
       IN=I
       GOTO 30
20     CONTINUE
30     H=(FNR-LNR)/(FWN-LWN)
       J=0
       X=XS
40     CONTINUE
       IF(X.LT.LWN) THEN
       IN=IN+1
       FWN=LWN
       LWN=WN(IN)
       FNR=LNR
       LNR=RN(IN)
       H=(FNR-LNR)/(FWN-LWN)
       ELSE
       J=J+1
       NROD(J)=LNR+H*(X-LWN)
       IF(X.LT.XE) GOTO 50
       X=X+DELTAF
       GOTO 40
       ENDIF
       IF(X.GT.XE) GOTO 40
50     CONTINUE
C      WRITE(*,*)' END OF NROD INTERPOLATION'
C       NFIX=NP
C       CALL WRITESC('NROD.SPC',NROD,NFIX,XS,XE,XT,YT,RESO,COMM,IER)
C       PAUSE ' END OF NROD INTERPOLATION' 
       END


C       MHLBTZS.FOR JULY,1992
CCCCCC  SUBROUTINE  HLBTZS/SLZ,JUNE/91

	SUBROUTINE HLBTZSUB(RNINF,RIMAGK,LT1,NEXTD,VLAST,NZERO,REALN)
	INTEGER*2 XX1(99)
	INTEGER PASS,SEQLOC,L(15)
	character*12 kextra
	COMMON/IN /REF,NFIX,xs,xe,XX1,iread,kextra
	DIMENSION X(16384),Y(16384),RIMAGK(*)
	DIMENSION RR(16384),RI(16384),REALN(*)
	EQUIVALENCE (RR(1),X(1)),(RI(1),Y(1)),(N2POW,NU)
	EQUIVALENCE (L13,L(1)),(L12,L(2)),(L11,L(3)),(L10,L(4)),
     1   (L9,L(5)),(L8,L(6)),(L7,L(7)),(L6,L(8)),(L5,L(9)),(L4,L(10))
     2   ,(L3,L(11)),(L2,L(12)),(L1,L(13)),(L0,L(14)),(LA,L(15))

	WRITE(*,'(A\)')'  DOING HILBERT TRANSFORM (VERSION 06/91)......'

	iread=iread+1
	if(iread.ne.1.and.nextd.lt.0) goto 400
	nnew=nfix
	if (nextd) 100, 300, 200

c       reading spectrum from disk
100     call appendspc(rimagk,nnew)

200     call appendline(lt1,nextd,vlast,rimagk,nnew)

300     do i=nnew+1, lt1
	   rimagk(i)=0.0
	end do

400     DO 1 I=1,lt1
1       RR(I)=RIMAGK(I)

C       CALCULATE NU=LOG2(N)+0.1
55      RNP=FLOAT(LT1)
	NU=INT(ALOG(RNP)/ALOG(2.)+0.00001)+1
	NP=2**NU
	NP2=NP/2
	IF(NP*(2**NZERO).GT.16384)
     +  STOP ' TOO MANY DATA POINTS!!! (MAX: 16K)'

C       SHIFT DATA TO THE MIDDLE OF ARRAY
	NDEL=NP-LT1
	DO 5 I=LT1,1,-1
5       RR(I+NDEL)=RR(I)
	DO 6 I=1,NDEL
6       RR(I)=0.

C       FOLD THE INPUT DATA AND SORT IT INTO TWO ARRAYS
	DO 8 I=1,NP2
	I2=I*2
	RR(I)=RR(I2-1)
8       RI(I)=RR(I2)
	RR(NP2+1)=0.0
	RI(NP2+1)=-RI(NP2)
	DO 10 I=NP2+2,NP
	NPI=NP-I+1
	RR(I)=-RR(NPI+1)
10      RI(I)=-RI(NPI)
	N4=0

C       CONSIDER ZERO-FILLING
	IF (NZERO.EQ.0) GOTO 15
	NU=NU+NZERO
	N=NP*(2**NZERO)
	N4=(N-NP)/2
	DO 12 I=NP+N4,N4+1,-1
	IN4=I-N4
	RR(I)=RR(IN4)
12      RI(I)=RI(IN4)
	DO 13 I=1,N4
	RR(I)=0.
13      RI(I)=0.
	DO 14 I=N-N4+1,N
	RR(I)=0.
14      RI(I)=0.
	NP=N
	NP2=NP/2
15      CONTINUE

C       SET TIMER FOR THE TRANSFORM
C       CALL GETTIM(IHR,IMIN,ISEC,I100TH)
C       WRITE(*,1011)IHR,IMIN,ISEC

	IFFT=1
C       CALL NGFFTOHT('Y',RR,RI)
C       COOLEY-TUKEY FFT ALGORITHM
99       NTHPOW=2**N2POW
	 N4POW=N2POW/2 
	 IF(N4POW.EQ.0) GOTO 93
	 DO 92 PASS=1,N4POW
	 NXTLTH=2**(N2POW-2*PASS) 
	 LENGTH=4*NXTLTH 
	 SCALE=6.283185307/LENGTH 
	 DO 92 J=1,NXTLTH
	 ARG=(J-1)*SCALE 
	 C1=COS(ARG) 
	 S1=SIN(ARG) 
	 C2=C1*C1-S1*S1 
	 S2=C1*S1*2 
	 C3=C1*C2-S1*S2 
	 S3=C2*S1+S2*C1 
	 DO 92 SEQLOC=LENGTH,NTHPOW,LENGTH
	 J1=SEQLOC-LENGTH+J 
	 J2=J1+NXTLTH 
	 J3=J2+NXTLTH 
	 J4=J3+NXTLTH 
	 R1=X(J1)+X(J3) 
	 R2=X(J1)-X(J3) 
	 R3=X(J2)+X(J4) 
	 R4=X(J2)-X(J4) 
	 AI1=Y(J1)+Y(J3)
	 AI2=Y(J1)-Y(J3)
	 AI3=Y(J2)+Y(J4)
	 AI4=Y(J2)-Y(J4)
	 X(J1)=R1+R3 
	 Y(J1)=AI1+AI3
	 IF(J.EQ.1) GOTO 91
	 X(J3)=C1*(R2+AI4)+S1*(AI2-R4)
	 Y(J3)=-S1*(R2+AI4)+C1*(AI2-R4)
	 X(J2)=C2*(R1-R3)+S2*(AI1-AI3)
	 Y(J2)=-S2*(R1-R3)+C2*(AI1-AI3)
	 X(J4)=C3*(R2-AI4)+S3*(AI2+R4)
	 Y(J4)=-S3*(R2-AI4)+C3*(AI2+R4)
	 GOTO 92
91       X(J3)=R2+AI4
	 Y(J3)=AI2-R4
	 X(J2)=R1-R3 
	 Y(J2)=AI1-AI3
	 X(J4)=R2-AI4
	 Y(J4)=AI2+R4
92       CONTINUE
93       IF(N2POW.EQ.2*N4POW) GOTO 95
	 DO 94 J=1,NTHPOW,2
	 R=X(J)+X(J+1) 
	 X(J+1)=X(J)-X(J+1) 
	 X(J)=R 
	 AI=Y(J)+Y(J+1)
	 Y(J+1)=Y(J)-Y(J+1) 
94       Y(J)=AI
95       DO 96 J=1,15
	 L(J)=1 
96       IF(J.LE.N2POW) L(J)=2**(N2POW+1-J)
	 IJ=1 
	 DO 97 JA=1,LA
	 DO 97 J0=JA,L0,LA
	 DO 97 J1=J0,L1,L0
	 DO 97 J2=J1,L2,L1
	 DO 97 J3=J2,L3,L2
	 DO 97 J4=J3,L4,L3
	 DO 97 J5=J4,L5,L4
	 DO 97 J6=J5,L6,L5
	 DO 97 J7=J6,L7,L6
	 DO 97 J8=J7,L8,L7
	 DO 97 J9=J8,L9,L8
	 DO 97 J10=J9,L10,L9
	 DO 97 J11=J10,L11,L10
	 DO 97 J12=J11,L12,L11
	 DO 97 JI=J12,L13,L12
	 IF(IJ.GE.JI) GOTO 97
	 R=X(IJ) 
	 X(IJ)=X(JI) 
	 X(JI)=R 
	 AI=Y(IJ)
	 Y(IJ)=Y(JI) 
	 Y(JI)=AI
97       IJ=IJ+1

C POST-PROCESSING NEXT
	ARG=3.1415927/FLOAT(NP)
	C1=COS(ARG)
	S1=-SIN(ARG)
	C1JX=1.
	S1JX=0.
	N2=NP/2
	N2P1=N2+1
	DO 120 J=2,N2P1
	NP2MJ=NP+2-J
	SORR1=X(J)+X(NP2MJ)
	SORI1=Y(J)-Y(NP2MJ)
	R=C1JX
	C1JX=C1JX*C1-S1JX*S1
	S1JX=R*S1+S1JX*C1
	SORR2=X(J)-X(NP2MJ)
	SORI2=Y(J)+Y(NP2MJ)
	SORR3=C1JX*SORR2-S1JX*SORI2
	SORI3=C1JX*SORI2+S1JX*SORR2
	Y(J)=0.5*(SORI1-SORR3)
	X(J)=0.5*(SORR1+SORI3)
	IF(J.EQ.N2P1) GOTO 120
	Y(NP2MJ)=-0.5*(SORI1+SORR3)
	X(NP2MJ)=0.5*(SORR1-SORI3)
120     CONTINUE
	X(1)=X(1)+Y(1)
	Y(1)=0.
	IF (IFFT.EQ.2) GOTO 20

C       SORT ODD POINTS OF THE IMAG. ARRAY INTO 1ST-HALF OF REAL ARRAY
C            AND EVEN POINTS INTO 1ST-HALF OF IMAGINARY ARRAY
C       ZERO 2ND HALVES OF BOTH ARRAYS
	DO 17 I=1,NP2
	I2=I*2
	RR(I)=RI(I2-1)
17      RI(I)=RI(I2)
	DO 18 I=NP2+1,NP
	RR(I)=0.
18      RI(I)=0.

C       CALL NGFFTOHT('Y',RR,RI)
	IFFT=2
	GOTO 99

C       SET TIMER
C20     CALL GETTIM(IHR,IMIN,ISEC,I100TH)
C       WRITE(*,*)
C       WRITE(*,1012)IHR,IMIN,ISEC

20      N4=N4*2+NDEL
	FACTOR=FLOAT(NP)
	DO 22 I=1,NFIX
22      REALN(I)=RNINF+RR(I+N4)/FACTOR
	WRITE(*,*)
	RETURN
	END

	subroutine appendspc(imagk,nnew)
	real k1,imagk
	integer*1 xt,yt
	INTEGER*2 XX1(99),n1
	character*12 kextra
	character*192 comm
	dimension k1(4096), imagk(*)
	COMMON/IN /REF,NFIX,xs,xe,XX1,iread,kextra

c       read k spectrum from disk
	call readsc(kextra,k1,n1,xs1,xe1,xt,yt,reso,comm,ier)

	dx1=(xs1-xe1)/float(n1-1)
	dx=(xs-xe)/float(nfix-1)

	ispace=(abs(dx)+0.001)/abs(dx1)
	
c       if the spectrum read from disk has bigger spacing, QUIT
	if(ispace.lt.1) then
		call msg('\  \')
		call msg('\ The k spectrum has bigger spacing.\')  
		call msg('\ It needs to be interpolated.\')
		call msg('\ Do interpolation in SpectraCalc and\') 
		call msg('\    re-start the refining !\')
		stop '  '

	else
		xstart=xe-dx
		xlimit=dx/100.0
		do i=1,n1
		   xtemp=xs1-dx1*float(i-1)
		   if(abs(xtemp-xstart).lt.xlimit) goto 10
		end do
10              nstart=i
		nadd=(n1-nstart+1)/ispace
		do i=1,nadd
		imagk(nfix+i)=k1(nstart+(i-1)*ispace)
		end do
		nnew=nnew+nadd
	endif
	end

	subroutine appendline(lt1,nextd,vlast,imagk,nnew)
	real imagk
	dimension imagk(*)

	nextdt=lt1-nnew
	nd=abs(nextd)
	if (nd.gt.nextdt) nd=nextdt
	dk=(imagk(nnew)-vlast)/float(nd)
	nextdt=nnew+nd

	do i=nnew+1,nextdt
	   imagk(i)=imagk(nnew)-dk*float(i-nnew)
	end do
	nnew=nextdt
	end
